unit UfrmMaitre;

// |===========================================================================|
// | UNITE UfrmMaitre                                                          |
// | dvelopp par F.BASSO 2006                                                |
// | Unit principale de l'application grpUser                                 |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.1.0.0 Ajout de la possibilit de slectionner plusieurs groupes       |
// |   1.0.0.0 Cration unit                                                  |
// |===========================================================================|

interface

uses
  Windows, SysUtils, Variants,  Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids,ufbreseau,
  ComCtrls, Classes, Controls;

type
  TFrmMaitre = class(TForm)
    lstGroupe: TListBox;
    cmdChargeGroupe: TButton;
    cmdExtraire: TButton;
    SaveDialog1: TSaveDialog;
    Edit1: TEdit;
    Edit2: TEdit;
    grdUtilisateur: TStringGrid;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Timer1: TTimer;
    procedure cmdChargeGroupeClick(Sender: TObject);
    procedure cmdExtraireClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lstGroupeClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

    strSrv : string;
    procedure RenitStringGrill;

  public
// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

    domaineName : string;
    userName : string;

  end;

var
  FrmMaitre: TFrmMaitre;

implementation

{$R *.dfm}
uses activex, StrUtils;

Function StrLectureVersion : String;

//  ___________________________________________________________________________
// | function  StrLectureVersion                                               |
// | _________________________________________________________________________ |
// || Permet d'avoir le numero de version de l'appli                          ||
// ||_________________________________________________________________________||
// || Sorties | String                                                        ||
// ||         |   Version de l'appli                                          ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

Var
  S         : String;
  Taille    : DWord;
  Buffer    : PChar;
  VersionPC : PChar;
  VersionL  : DWord;

Begin
  Result:='';
  // On demande la taille des informations sur l'application
  S := Application.ExeName;
  Taille := GetFileVersionInfoSize(PChar(S), Taille);
  If Taille>0
  Then Try
  // Rservation en mmoire d'une zone de la taille voulue
    Buffer := AllocMem(Taille);
  // Copie dans le buffer des informations
    GetFileVersionInfo(PChar(S), 0, Taille, Buffer);
  // Recherche de l'information de version
    If VerQueryValue(Buffer, PChar('\StringFileInfo\040C04E4\FileVersion'), Pointer(VersionPC), VersionL)
      Then Result:=VersionPC;
  Finally
    FreeMem(Buffer, Taille);
  End;
End;


// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Prive                                                             #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TFrmMaitre.RenitStringGrill ;
//  ___________________________________________________________________________
// | procedure TFrmMaitre.RenitStringGrill                                     |
// | _________________________________________________________________________ |
// || Permet de vider les grilles et de les mettre en forme                   ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i : integer;
begin
// ****************************************************************************
// * Effacement de la grille                                                  *
// ****************************************************************************

  grdUtilisateur.RowCount := 2;
  for i := 0 to grdUtilisateur.ColCount -1 do
    grdUtilisateur.Cells[i,1] := '';

// ****************************************************************************
// * affichage des titre de colonnes                                          *
// ****************************************************************************

  grdUtilisateur.Cells[0,0]:= 'Login';
  grdUtilisateur.Cells[1,0]:= 'Nom Complet';
  grdUtilisateur.Cells[2,0]:= 'Description';
  grdUtilisateur.Cells[3,0]:= 'Date Expiration';
  grdUtilisateur.Cells[4,0]:= 'Groupe';

// ****************************************************************************
// * definition de la largeur des colonnes                                    *
// ****************************************************************************

  grdUtilisateur.ColWidths[1]:= 150;
  grdUtilisateur.ColWidths[2]:= 150;
  grdUtilisateur.ColWidths[3]:= 70;
end;


// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Evnementiel                                                       #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TFrmMaitre.cmdChargeGroupeClick(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TFrmMaitre.cmdChargeGroupeClick                                 |
// | _________________________________________________________________________ |
// || Permet de charger la liste des groupes globaux                          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  listeGroupe : TTabGroupeGlobaux ;
  i , nbGroupe : integer;
begin
  nbGroupe := GetListeGroupeGlobaux(strSrv,ListeGroupe);
  lstGroupe.Clear ;
  for i := 0 to nbGroupe -1 do
    lstGroupe.Items.Add(ListeGroupe[i].nom);
end;

procedure TFrmMaitre.cmdExtraireClick(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TFrmMaitre.cmdExtraireClick                                     |
// | _________________________________________________________________________ |
// || Permet d'extraire dans un fichier csv la liste des utilisateurs         ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var i,j : integer;
    str : string;
    f : textfile;
begin
  if SaveDialog1.Execute then
  begin

// ****************************************************************************
// * Cration d'un fichier vide                                               *
// ****************************************************************************

    AssignFile (f,SaveDialog1.FileName);
    rewrite(f);
    for i := 0 to grdUtilisateur.RowCount -1 do
    begin

// ****************************************************************************
// * Cration de chaques lignes en concatenant les colonnes avec ';'          *
// ****************************************************************************

      str:='';
      for j := 0 to grdUtilisateur.ColCount -1 do
        str := str + grdUtilisateur.cells[j,i] + ';';
      Writeln ( f,str);
    end;
    closefile(f);
  end;
end;

procedure TFrmMaitre.FormCreate(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TFrmMaitre.FormCreate                                           |
// | _________________________________________________________________________ |
// || Permet a la cration de la fiche de recuperer le domaine et le BDC PDC  ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var

  user : ARRAY[0..255] OF Char;
  x:longword;

begin
  caption := caption +' V'+ StrLectureVersion ;
  RenitStringGrill;
  show;
  application.ProcessMessages ;
  x:=255;

// ****************************************************************************
// * Rcuperration de l'utilisateur du domaine et du serveur                  *
// ****************************************************************************

  GetUserName(user,x);
  GetNomDomaine(domaineName ,x);
  userName    := user;
  edit1.Text  := domaineName;
  edit2.text  := userName;
  GetNomTousPdc('',domaineName,strSrv);
  edit1.Text := edit1.Text  + ' -> ' +strsrv;
  if strsrv = '' then
  begin

// ****************************************************************************
// * Si le serveur n'est pas trouv on desactive les boutons                  *
// ****************************************************************************

    cmdChargeGroupe.Enabled := false;
    cmdExtraire.Enabled := false;
    showmessage('Aucun serveur n''a t trouv !');
  end;
end;


procedure TFrmMaitre.lstGroupeClick(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TFrmMaitre.lstGroupeClick                                       |
// | _________________________________________________________________________ |
// || Permet de rniitaliser le timer pour l'affichage de la liste des        ||
// || utilisateurs du groupe slectionn                                      ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  timer1.Enabled := false;
  timer1.Enabled := true;
end;

procedure TFrmMaitre.Timer1Timer(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TFrmMaitre.Timer1Timer                                          |
// | _________________________________________________________________________ |
// || Permet  chaque dclenchement du timer d'afficher la liste des          ||
// || utilisateurs du groupe slectionn                                      ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i,j ,nbUser,nbusert ,offset: integer;
  listeUser : TTabUtilisateur ;
begin
  timer1.Enabled := false;
  lstGroupe.Enabled := false;
  RenitStringGrill;
  grdUtilisateur.Visible := false;
  ProgressBar1.Position := 0;
  Application.ProcessMessages ;
  nbusert := 0 ;
  if lstGroupe.SelCount > 0 then
    for j := 0 to lstGroupe.Items.Count -1 do
      if lstGroupe.Selected[j] then
      begin
// ****************************************************************************
// * Chargement de la liste des utilisateurs du groupe slectionn            *
// ****************************************************************************

        nbUser := GetListeUtilisateursGroupeGlobal(strSrv ,lstGroupe.Items.Strings[j],listeUser ,ProgressBar1);
        if nbuser > 1 then
        begin
          offset := nbusert;
          nbusert := nbusert + nbuser;
          grdUtilisateur.RowCount := nbusert + 1;
        end;

// ****************************************************************************
// * Affichage dans la grille                                                 *
// ****************************************************************************

        for i := 0 to nbuser -1 do
        begin
          grdUtilisateur.Cells[0,offset + i+1] := listeUser[i].login ;
          grdUtilisateur.Cells[1,offset + i+1] := listeUser[i].nom_complet ;
          grdUtilisateur.Cells[2,offset + i+1] := listeUser[i].description ;
          grdUtilisateur.Cells[3,offset + i+1] := IfThen (listeUser[i].date_expiration =0,'Jamais',datetostr(listeUser[i].date_expiration)) ;
          grdUtilisateur.Cells[4,offset + i+1] := lstGroupe.Items.Strings[j];
        end;
      end;
  grdUtilisateur.Visible := true;
  lstGroupe.Enabled := true;
  lstGroupe.SetFocus ;
end;

end.
